/*---------------- "exampleFragmentShader.frag" ----------------*/
// QUELLE vom Grundgerst: http://en.wikipedia.org/wiki/Vertex_Buffer_Object
// 
 
#version 150 // Specify which version of GLSL we are using.
 
precision highp float; // Video card drivers require this line to function properly
 
uniform sampler2D posX;
uniform sampler2D posY;
uniform sampler2D posZ;
uniform sampler2D negX;
uniform sampler2D negY;
uniform sampler2D negZ;

in vec2 UV;
in vec3 normal;
in vec3 normal_world;
in vec3 lightDirection;
in vec3 eyeDirection;
in vec3 worldCoordinates;
in vec3 lightPosition_worldspace;

out vec3 color;


void main() 
{
	color = vec3(0.0, 0.0, 0.0);

	vec3 r = reflect(eyeDirection, normal_world);

	vec2 c = vec2(r.y/abs(r.x), r.z/abs(r.x));

	if(max(max(abs(r.x), abs(r.y)), abs(r.z)) == abs(r.x)){
		if(r.x >= 0){
			c = vec2(r.z/abs(r.x), -r.y/abs(r.x));
			vec2 texCoord = vec2((c.x + 1)/2, (c.y + 1)/2);
			color = texture( posX, texCoord ).rgb;
		}
		else{
			c = vec2(r.z/abs(r.x), -r.y/abs(r.x));
			vec2 texCoord = vec2((c.x + 1)/2, (c.y + 1)/2);
			color = texture( negX, texCoord ).rgb;
		}
	}
	else if(max(max(abs(r.x), abs(r.y)), abs(r.z)) == abs(r.y)){
		if(r.y >= 0){
			c = vec2(-r.x/abs(r.y), r.z/abs(r.y));
			vec2 texCoord = vec2((c.x + 1)/2, (c.y + 1)/2);
			color = texture( posY, texCoord ).rgb;
		}
		else{
			c = vec2(r.x/abs(r.y), r.z/abs(r.y));
			vec2 texCoord = vec2((c.x + 1)/2, (c.y + 1)/2);
			color = texture( negY, texCoord ).rgb;
		}
	}
	else if(max(max(abs(r.x), abs(r.y)), abs(r.z)) == abs(r.z)){
		if(r.z >= 0){
			c = vec2(r.x/abs(r.z), -r.y/abs(r.z));
			vec2 texCoord = vec2((c.x + 1)/2, (c.y + 1)/2);
			color = texture( posZ, texCoord ).rgb;
		}
		else{
			c = vec2(r.x/abs(r.z), -r.y/abs(r.z));
			vec2 texCoord = vec2((c.x + 1)/2, (c.y + 1)/2);
			color = texture( negZ, texCoord ).rgb;
		}
	}

	color = color + vec3(0,0.4,0);
}
/*--------------------------------------------------------------*/