/*----------------- "exampleVertexShader.vert" -----------------*/
// QUELLE: http://en.wikipedia.org/wiki/Vertex_Buffer_Object
 
#version 150 // Specify which version of GLSL we are using.
 


uniform mat4 M;
uniform mat4 V;
uniform mat4 P;

in vec3 in_Position;
in vec2 vertexUV;
in vec3 vertexNormal_modelspace;

out vec2 UV;
out vec3 normal;
out vec3 lightDirection;
out vec3 eyeDirection;
out vec3 worldCoordinates;
out vec3 lightPosition_worldspace;
 
void main() 
{
	// TODO IMPORT
	lightPosition_worldspace = vec3(0,0,0);

	mat4 MVP = P * V * M;

    vec4 v = vec4(in_Position,1); // Transform an homogeneous 4D vector, remember ?
    gl_Position = MVP * v ;
		
	// Vector that goes from the vertex to the camera, in camera space.
	// In camera space, the camera is at the origin (0,0,0).
	vec3 vertexPosition_cameraspace = ( V * M * vec4(in_Position,1)).xyz;
	vec3 eyeDirection_cameraspace = vec3(0,0,0) - vertexPosition_cameraspace;
 
 	// Vector that goes from the vertex to the light, in camera space. M is ommited because it's identity.
	vec3 lightPosition_cameraspace = ( V * vec4(lightPosition_worldspace,1)).xyz;
	
	lightDirection = lightPosition_cameraspace + eyeDirection_cameraspace;
	normal = ( V * M * vec4(vertexNormal_modelspace,0)).xyz; // Only correct if ModelMatrix does not scale the model ! Use its inverse transpose if not.
	eyeDirection = eyeDirection_cameraspace;
	worldCoordinates = (M * vec4(in_Position,1)).xyz;;
	UV = vertexUV;
}
/*--------------------------------------------------------------*/